#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t; cin >> t;
    vector<int> n(t);

    vector<bool> da(t);
    for(int i = 0; i < t; i++)
        da[i] = true;

    for(int i = 0; i < t; i++)
    {
        cin >> n[i];
        vector<int> a(n[i]);
        for(int j = 0; j < n[i]; j++)
        {
            cin >> a[j];
        }
        vector<int> b(n[i]);
        for(int j = 0; j < n[i]; j++)
        {
            cin >> b[j];
        }

        for(int j = 0; j < n[i]; j++)
        {
            for(int k = 0; k < n[i]; k++)
            {
                if(a[j]!=0 && b[k]!=0 && a[j]==b[k] && abs(j-k)%2!=0)
                {
                    da[i] = false;
                    break;
                }
                if(a[j]!=0 && b[k]!=0 && a[j]==(0-b[k]) && abs(j-k)%2==0)
                {
                    da[i] = false;
                    break;
                }
            }
            if(da[i]==false)
                break;
        }
    }

    for(int i = 0; i < t; i++)
    {
        if(da[i])
            cout << "DA" << "\n";
        else
            cout << "NE" << "\n";
    }
    return 0;
}